diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
index 65e7dc69a..1dc35b596 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentInfoOverlay.java
@@ -19,17 +19,20 @@ import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 
-import java.util.ArrayList;
-import java.util.List;
-
 import static net.minecraft.core.util.helper.Utils.floor10;
 
 public class HudComponentInfoOverlay extends HudComponentMovable {
+    public static int MAX_LINES = 16;
 
-    private record RenderLine(String text, int color) {}
+    protected @NotNull StringBuilder @NotNull [] lines = new StringBuilder[MAX_LINES];
+    protected int @NotNull [] colors = new int[MAX_LINES];
+    protected int lineIndex = 0;
 
     public HudComponentInfoOverlay(String key, Layout layout) {
         super(key, 175, 150, layout);
+        for (int i = 0; i < this.lines.length; i++) {
+            this.lines[i] = new StringBuilder();
+        }
     }
 
     @Override
@@ -37,7 +40,14 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
         return GameSettings.IMMERSIVE_MODE.drawOverlays() && !GameSettings.SHOW_DEBUG_SCREEN.value;
     }
 
-    private void drawAlignedString(String text, int boxX, int boxY, int boxWidth, int argb) {
+    private @NotNull StringBuilder addLine(int color) {
+        var builder = this.lines[this.lineIndex]; builder.setLength(0);
+        this.colors[this.lineIndex] = color;
+        this.lineIndex++;
+        return builder;
+    }
+
+    private void drawAlignedString(@NotNull CharSequence text, int boxX, int boxY, int boxWidth, int argb) {
         int textWidth = mc.font.stringWidth(text);
         float xMult = GameSettings.HORIZONTAL_INFO_TEXT_ALIGNMENT.value.multiplier;
         int padding = 2;
@@ -54,6 +64,7 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
 
     @Override
     public void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick) {
+        mc.font.startDrawingDeferred();
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
@@ -76,35 +87,36 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
             }
         }
 
-        List<RenderLine> lines = new ArrayList<>();
+        this.lineIndex = 0;
 
         if (GameSettings.VERSION_IN_OVERLAY.value) {
             int color = (GameSettings.OVERLAY_MODE.value == 2) ? 0xFFFFFF60 : 0xFFFFFFFF;
-            lines.add(new RenderLine("Better than Adventure! " + TextFormatting.WHITE + Global.VERSION, color));
+            addLine(color).append("Better than Adventure! ").append(TextFormatting.WHITE).append(Global.VERSION);
+
         }
 
         if (GameSettings.FPS_IN_OVERLAY.value) {
-            lines.add(new RenderLine(mc.lingDebugFPS, 0xFFFFFFFF));
+            addLine(0xFFFFFFFF).append(mc.lingDebugFPS);
         }
 
         if (compass) {
             if (GameSettings.COORDS_IN_OVERLAY.value) {
                 if (GameSettings.OVERLAY_MODE.value == 0) {
-                    lines.add(new RenderLine("x: " + floor10(mc.thePlayer.x) + " y: " + floor10(mc.thePlayer.y) + " z: " + floor10(mc.thePlayer.z), 0xFFFFFFFF));
+                    addLine(0xFFFFFFFF).append("x: ").append(floor10(mc.thePlayer.x)).append(" y: ").append(floor10(mc.thePlayer.y)).append(" z: ").append(floor10(mc.thePlayer.z));
                 }
                 if (GameSettings.OVERLAY_MODE.value == 1) {
-                    lines.add(new RenderLine("x: " + floor10(mc.thePlayer.x), 0xFFFFFFFF));
-                    lines.add(new RenderLine("y: " + floor10(mc.thePlayer.y), 0xFFFFFFFF));
-                    lines.add(new RenderLine("z: " + floor10(mc.thePlayer.z), 0xFFFFFFFF));
+                    addLine(0xFFFFFFFF).append("x: ").append(floor10(mc.thePlayer.x));
+                    addLine(0xFFFFFFFF).append("y: ").append(floor10(mc.thePlayer.y));
+                    addLine(0xFFFFFFFF).append("z: ").append(floor10(mc.thePlayer.z));
                 }
                 if (GameSettings.OVERLAY_MODE.value == 2) {
-                    lines.add(new RenderLine("x: " + floor10(mc.thePlayer.x), 0xFFFF8080));
-                    lines.add(new RenderLine("y: " + floor10(mc.thePlayer.y), 0xFF80FF80));
-                    lines.add(new RenderLine("z: " + floor10(mc.thePlayer.z), 0xFF8080FF));
+                    addLine(0xFFFF8080).append("x: ").append(floor10(mc.thePlayer.x));
+                    addLine(0xFF80FF80).append("y: ").append(floor10(mc.thePlayer.y));
+                    addLine(0xFF8080FF).append("z: ").append(floor10(mc.thePlayer.z));
                 }
             }
             if (GameSettings.DIRECTION_IN_OVERLAY.value) {
-                lines.add(new RenderLine(I18n.getInstance().translateKey(HudIngame.getFacingDirection(mc.thePlayer).translationKey), 0xFFFFFFFF));
+                addLine(0xFFFFFFFF).append(I18n.getInstance().translateKey(HudIngame.getFacingDirection(mc.thePlayer).translationKey));
             }
         }
 
@@ -112,11 +124,11 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
             if (GameSettings.TIME_IN_OVERLAY.value) {
                 int color = (GameSettings.OVERLAY_MODE.value == 2) ? 0xFFFFFF80 : 0xFFFFFFFF;
                 if (GameSettings.OVERLAY_MODE.value == 0) {
-                    lines.add(new RenderLine(String.format("%s %s %d", HudIngame.getTimeString(mc), I18n.getInstance().translateKey("unit.day"), mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), color));
+                    addLine(color).append(HudIngame.getTimeString(mc)).append(" ").append(I18n.getInstance().translateKey("unit.day")).append(" ").append(mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS);
                 }
                 if (GameSettings.OVERLAY_MODE.value > 0) {
-                    lines.add(new RenderLine(HudIngame.getTimeString(mc), color));
-                    lines.add(new RenderLine(String.format("%s %d", I18n.getInstance().translateKey("unit.day"), mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS), color));
+                    addLine(color).append(HudIngame.getTimeString(mc));
+                    addLine(color).append(I18n.getInstance().translateKey("unit.day")).append(" ").append(mc.currentWorld.getWorldTime() / Global.DAY_LENGTH_TICKS);
                 }
             }
         }
@@ -125,22 +137,23 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
             if (GameSettings.SEASON_IN_OVERLAY.value) {
                 Season season = mc.currentWorld.getSeasonManager().getCurrentSeason();
                 if (season != null) {
-                    lines.add(new RenderLine(season.getTranslatedName(), GameSettings.OVERLAY_MODE.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF));
+                    addLine(GameSettings.OVERLAY_MODE.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF).append(season.getTranslatedName());
                 }
             }
             if (GameSettings.WEATHER_IN_OVERLAY.value) {
                 Weather weather = mc.currentWorld.getCurrentWeather();
                 if (weather != null && weather != mc.currentWorld.getWorldType().getDefaultWeather()) {
-                    lines.add(new RenderLine(I18n.getInstance().translateKey(weather.getNameLanguageKey()), GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF));
+                    addLine(GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF).append(I18n.getInstance().translateKey(weather.getNameLanguageKey()));
                 }
             }
             if (GameSettings.BIOME_IN_OVERLAY.value) {
                 String key = mc.currentWorld.getBlockBiome(new TilePos(mc.thePlayer)).translationKey;
-                lines.add(new RenderLine(I18n.getInstance().translateKey(key), 0xFFFFFFFF));
+                addLine(0xFFFFFFFF).append(I18n.getInstance().translateKey(key));
             }
         }
 
-        drawLines(lines, x, y);
+        drawLines(x, y);
+        mc.font.draw(0);
     }
 
     @Override
@@ -148,16 +161,15 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
-        List<RenderLine> lines = new ArrayList<>();
+        this.lineIndex = 0;
 
         int versionBaseColor = (GameSettings.OVERLAY_MODE.value == 2) ? 0xFFFFFF60 : 0xFFFFFFFF;
         boolean versionEnabled = GameSettings.VERSION_IN_OVERLAY.value;
 
-        String versionText = "Better than Adventure! " + (versionEnabled ? TextFormatting.WHITE : "") + Global.VERSION;
-        lines.add(new RenderLine(versionText, getPreviewColor(versionBaseColor, versionEnabled)));
+        addLine(getPreviewColor(versionBaseColor, versionEnabled)).append("Better than Adventure! ").append(versionEnabled ? TextFormatting.WHITE : "").append(Global.VERSION);
 
         boolean fpsEnabled = GameSettings.FPS_IN_OVERLAY.value;
-        lines.add(new RenderLine("127 fps", getPreviewColor(0xFFFFFFFF, fpsEnabled)));
+        addLine(getPreviewColor(0xFFFFFFFF, fpsEnabled)).append("127 fps");
 
         final double px = 372.853;
         final double py = 64.355;
@@ -165,60 +177,59 @@ public class HudComponentInfoOverlay extends HudComponentMovable {
         boolean coordsEnabled = GameSettings.COORDS_IN_OVERLAY.value;
 
         if (GameSettings.OVERLAY_MODE.value == 0) {
-            lines.add(new RenderLine("x: " + floor10(px) + " y: " + floor10(py) + " z: " + floor10(pz), getPreviewColor(0xFFFFFFFF, coordsEnabled)));
+            addLine(getPreviewColor(0xFFFFFFFF, coordsEnabled)).append("x: ").append(floor10(px)).append(" y: ").append(floor10(py)).append(" z: ").append(floor10(pz));
         } else if (GameSettings.OVERLAY_MODE.value == 1) {
-            lines.add(new RenderLine("x: " + floor10(px), getPreviewColor(0xFFFFFFFF, coordsEnabled)));
-            lines.add(new RenderLine("y: " + floor10(py), getPreviewColor(0xFFFFFFFF, coordsEnabled)));
-            lines.add(new RenderLine("z: " + floor10(pz), getPreviewColor(0xFFFFFFFF, coordsEnabled)));
+            addLine(getPreviewColor(0xFFFFFFFF, coordsEnabled)).append("x: ").append(floor10(px));
+            addLine(getPreviewColor(0xFFFFFFFF, coordsEnabled)).append("y: ").append(floor10(py));
+            addLine(getPreviewColor(0xFFFFFFFF, coordsEnabled)).append("z: ").append(floor10(pz));
         } else if (GameSettings.OVERLAY_MODE.value == 2) {
-            lines.add(new RenderLine("x: " + floor10(px), getPreviewColor(0xFFFF8080, coordsEnabled)));
-            lines.add(new RenderLine("y: " + floor10(py), getPreviewColor(0xFF80FF80, coordsEnabled)));
-            lines.add(new RenderLine("z: " + floor10(pz), getPreviewColor(0xFF8080FF, coordsEnabled)));
+            addLine(getPreviewColor(0xFFFF8080, coordsEnabled)).append("x: ").append(floor10(px));
+            addLine(getPreviewColor(0xFF80FF80, coordsEnabled)).append("y: ").append(floor10(py));
+            addLine(getPreviewColor(0xFF8080FF, coordsEnabled)).append("z: ").append(floor10(pz));
         }
 
         boolean dirEnabled = GameSettings.DIRECTION_IN_OVERLAY.value;
-        lines.add(new RenderLine(I18n.getInstance().translateKey(Direction.NORTH.translationKey), getPreviewColor(0xFFFFFFFF, dirEnabled)));
+        addLine(getPreviewColor(0xFFFFFFFF, dirEnabled)).append(I18n.getInstance().translateKey(Direction.NORTH.translationKey));
 
         int clockColor = (GameSettings.OVERLAY_MODE.value == 2) ? 0xFFFFFF80 : 0xFFFFFFFF;
         boolean timeEnabled = GameSettings.TIME_IN_OVERLAY.value;
 
         if (GameSettings.OVERLAY_MODE.value == 0) {
-            lines.add(new RenderLine(String.format("%s %s %d", "8:32", I18n.getInstance().translateKey("unit.day"), 500), getPreviewColor(clockColor, timeEnabled)));
+            addLine(getPreviewColor(clockColor, timeEnabled)).append("8:32 ").append(I18n.getInstance().translateKey("unit.day")).append(" ").append(500);
         } else if (GameSettings.OVERLAY_MODE.value > 0) {
-            lines.add(new RenderLine("8:32", getPreviewColor(clockColor, timeEnabled)));
-            lines.add(new RenderLine(String.format("%s %d", I18n.getInstance().translateKey("unit.day"), 500), getPreviewColor(clockColor, timeEnabled)));
+            addLine(getPreviewColor(clockColor, timeEnabled)).append("8:32");
+            addLine(getPreviewColor(clockColor, timeEnabled)).append(I18n.getInstance().translateKey("unit.day")).append(" ").append(500);
         }
 
         Season season = Seasons.OVERWORLD_SUMMER;
         boolean seasonEnabled = GameSettings.SEASON_IN_OVERLAY.value;
-        lines.add(new RenderLine(season.getTranslatedName(), getPreviewColor(GameSettings.OVERLAY_MODE.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF, seasonEnabled)));
+        addLine(getPreviewColor(GameSettings.OVERLAY_MODE.value == 2 ? 0xFF80FFFF : 0xFFFFFFFF, seasonEnabled)).append(season.getTranslatedName());
 
         Weather weather = Weathers.OVERWORLD_FOG;
         boolean weatherEnabled = GameSettings.WEATHER_IN_OVERLAY.value;
-        lines.add(new RenderLine(I18n.getInstance().translateKey(weather.getNameLanguageKey()), getPreviewColor(GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF, weatherEnabled)));
+        addLine(getPreviewColor(GameSettings.OVERLAY_MODE.value == 2 ? 0xFFFF80FF : 0xFFFFFFFF, weatherEnabled)).append(I18n.getInstance().translateKey(weather.getNameLanguageKey()));
 
         String biomeKey = Biomes.OVERWORLD_GRASSLANDS.translationKey;
         boolean biomeEnabled = GameSettings.BIOME_IN_OVERLAY.value;
-        lines.add(new RenderLine(I18n.getInstance().translateKey(biomeKey), getPreviewColor(0xFFFFFFFF, biomeEnabled)));
+        addLine(getPreviewColor(0xFFFFFFFF, biomeEnabled)).append(I18n.getInstance().translateKey(biomeKey));
 
-        drawLines(lines, x, y);
+        drawLines(x, y);
     }
 
-    private void drawLines(@NotNull List<RenderLine> lines, int x, int y) {
-        if (lines.isEmpty()) return;
+    private void drawLines(int x, int y) {
+        final int size = this.lineIndex;
 
-        int lineHeight = 10;
-        int totalHeight = lines.size() * lineHeight;
+        final int lineHeight = 10;
+        final int totalHeight = size * lineHeight;
 
-        float yMult = GameSettings.VERTICAL_INFO_TEXT_ALIGNMENT.value.multiplier;
+        final float yMult = GameSettings.VERTICAL_INFO_TEXT_ALIGNMENT.value.multiplier;
 
         int padding = 2;
         int startY = y + padding + (int) ((this.getBaseYSize() - (padding * 2) - totalHeight) * yMult);
 
-        for (int i = 0; i < lines.size(); i++) {
-            RenderLine line = lines.get(i);
+        for (int i = 0; i < size; i++) {
             int currentY = startY + (i * lineHeight);
-            drawAlignedString(line.text, x, currentY, this.getBaseXSize(), line.color);
+            drawAlignedString(this.lines[i], x, currentY, this.getBaseXSize(), this.colors[i]);
         }
     }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
index ae1b12c06..913cdd37c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
@@ -157,12 +157,14 @@ public class HudComponentLog extends HudComponentMovable {
         int totalHeight = lines.length * LINE_HEIGHT;
         int startY = y + PADDING + (int) ((this.getBaseYSize() - (PADDING * 2) - totalHeight) * yMult);
 
+        sr.startDrawingDeferred();
         for (int i = 0; i < lines.length; i++) {
             String line = lines[i];
             int currentY = startY + (i * LINE_HEIGHT);
             int color = 0x00_FF_FF_FF + ((int) (opacities[i] * 0xFF) << 24);
             drawAlignedString(sr, line, x, currentY, this.getBaseXSize(), color);
         }
+        sr.draw(0);
         GLRenderer.disableState(State.BLEND);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index bc100ff7b..1481a19ca 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -380,6 +380,7 @@ public abstract class OptionsPages {
                 .withComponent(new KeyBindingComponent(GameSettings.KEY_SMOOTH_LIGHTING))
                 .withComponent(new KeyBindingComponent(GameSettings.KEY_RELEASE_CURSOR))
                 .withComponent(new KeyBindingComponent(GameSettings.KEY_LOAD_CHUNKS_QUICKLY))
+                .withComponent(new KeyBindingComponent(GameSettings.KEY_TOGGLE_FRAME_LIMIT))
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index f10ea0fbc..e8445791d 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -648,6 +648,7 @@ public final class GameSettings {
     public static final @NotNull KeyBinding KEY_TOGGLE_TEXTURE_ATLAS = register(new KeyBinding("key.debug.textureAtlas"));
     public static final @NotNull KeyBinding KEY_SHIFT_TEXTURE_ATLAS_LAYER = register(new KeyBinding("key.debug.textureAtlasLayer"));
     public static final @NotNull KeyBinding KEY_LOAD_CHUNKS_QUICKLY = register(new KeyBinding("key.debug.loadChunksQuickly"));
+    public static final @NotNull KeyBinding KEY_TOGGLE_FRAME_LIMIT = register(new KeyBinding("key.debug.toggleFrameLimit"));
 
     static {
         DEBUG_KEYS.add(KEY_SHOW_SHORTCUTS);
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionFont.java b/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
index 89fc679e5..4b4af2dbe 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionFont.java
@@ -24,7 +24,7 @@ public class OptionFont extends OptionToggleable<@NotNull Font> implements Toggl
 
     @Override
     public void toggle(final int delta) {
-        this.value = Fonts.fontAtIndex(DynamicTexture.pmod(getValueIndex() + delta, size()));
+        this.value = Fonts.fontAtIndex(Math.floorMod(getValueIndex() + delta, size()));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java b/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java
index 37242801f..fb94ec95b 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionToggleable.java
@@ -20,7 +20,7 @@ public abstract class OptionToggleable<E> extends Option<E> implements Toggleabl
 	}
 	
 	public void toggle(int delta) {
-		this.value = this.values[DynamicTexture.pmod(getValueIndex() + delta, this.values.length)];
+		this.value = this.values[Math.floorMod(getValueIndex() + delta, this.values.length)];
 	}
 	
 	public int getValueIndex() {
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java b/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
index 6cf41251b..3169e22b3 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionTooltip.java
@@ -23,7 +23,7 @@ public class OptionTooltip extends OptionToggleable<String> implements Toggleabl
 
     @Override
     public void toggle(final int delta) {
-        this.value = TooltipElement.stylesIdList.get(DynamicTexture.pmod(getValueIndex() + delta, size()));
+        this.value = TooltipElement.stylesIdList.get(Math.floorMod(getValueIndex() + delta, size()));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index f18de7261..06a32b2fc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -241,14 +241,13 @@ public class FogManager {
             return this;
         }
 
-        public @NotNull FogState copy() {
-            FogState newState = new FogState();
-            newState.fogColor.set(this.fogColor);
-            newState.fogMode = this.fogMode;
-            newState.fogStart = this.fogStart;
-            newState.fogEnd = this.fogEnd;
-            newState.fogDensity = this.fogDensity;
-            return newState;
+        public @NotNull FogState copy(@NotNull FogState dest) {
+            dest.fogColor.set(this.fogColor);
+            dest.fogMode = this.fogMode;
+            dest.fogStart = this.fogStart;
+            dest.fogEnd = this.fogEnd;
+            dest.fogDensity = this.fogDensity;
+            return dest;
         }
 
         public enum Mode {
diff --git a/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java b/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
index ee5c2aeff..4f6af8aef 100644
--- a/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
+++ b/game/client/src/main/java/net/minecraft/client/render/culling/CameraFrustum.java
@@ -8,7 +8,7 @@ import org.joml.FrustumIntersection;
 import org.joml.Matrix4f;
 import org.joml.primitives.AABBdc;
 
-public class CameraFrustum {
+public final class CameraFrustum {
     private final @NotNull ICamera camera;
     private static final @NotNull FrustumIntersection frustum = new FrustumIntersection();
     private static final @NotNull Matrix4f matrix4f = new Matrix4f();
@@ -40,7 +40,17 @@ public class CameraFrustum {
 
     public boolean isVisible(@NotNull AABBdc aabb, float partialTick) {
         if (GameSettings.FRUSTUM_CULLING.value) {
-            return cubeInFrustum(aabb, partialTick);
+            final double x = this.camera.getX(partialTick);
+            final double y = this.camera.getY(partialTick);
+            final double z = this.camera.getZ(partialTick);
+            return frustum.testAab(
+                (float) (aabb.minX() - x),
+                (float) (aabb.minY() - y),
+                (float) (aabb.minZ() - z),
+                (float) (aabb.maxX() - x),
+                (float) (aabb.maxY() - y),
+                (float) (aabb.maxZ() - z)
+            );
         } else {
             return true;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
index 489609947..78910d053 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTexture.java
@@ -44,11 +44,6 @@ public abstract class DynamicTexture {
         return this.imageData[layer];
     }
 
-	public static int pmod(int a, int b) {
-		while(a < 0) a += b;
-		return a % b;
-	}
-
 	public static void putPixel(byte[] array, int i, int color) {
 		int r = (color >> 16) & 0xFF;
 		int g = (color >>  8) & 0xFF;
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
index fe3177505..8118f9267 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaFlowing.java
@@ -4,6 +4,8 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 
+import static java.lang.Math.floorMod;
+
 public class DynamicTextureLavaFlowing extends DynamicTexture {
 
 	private float[] arr1;
@@ -47,21 +49,21 @@ public class DynamicTextureLavaFlowing extends DynamicTexture {
 
 				for (_x = x - 1; _x <= x + 1; ++_x) {
 					for (_y = y - 1; _y <= y + 1; ++_y) {
-						var8 = pmod(_x + var4, this.targetTexture.width);
-						var9 = pmod(_y + var5, this.targetTexture.height);
+						var8 = floorMod(_x + var4, this.targetTexture.width);
+						var9 = floorMod(_y + var5, this.targetTexture.height);
 						var3 += this.arr1[var8 + var9 * this.targetTexture.width];
 					}
 				}
 
 				this.arr2[x + y * this.targetTexture.width] = var3 / 10.0F
-						+ (this.arr3[(pmod(x, this.targetTexture.width))
-						+ (pmod(y, this.targetTexture.height)) * this.targetTexture.width]
-						+ this.arr3[(pmod(x + 1, this.targetTexture.width))
-						+ (pmod(y, this.targetTexture.height)) * this.targetTexture.width]
-						+ this.arr3[(pmod(x + 1, this.targetTexture.width))
-						+ (pmod(y + 1, this.targetTexture.height)) * this.targetTexture.width]
-						+ this.arr3[(pmod(x, this.targetTexture.width))
-						+ (pmod(y + 1, this.targetTexture.height)) * this.targetTexture.width]) / 4.0F * 0.8F;
+						+ (this.arr3[(floorMod(x, this.targetTexture.width))
+						+ (floorMod(y, this.targetTexture.height)) * this.targetTexture.width]
+						+ this.arr3[(floorMod(x + 1, this.targetTexture.width))
+						+ (floorMod(y, this.targetTexture.height)) * this.targetTexture.width]
+						+ this.arr3[(floorMod(x + 1, this.targetTexture.width))
+						+ (floorMod(y + 1, this.targetTexture.height)) * this.targetTexture.width]
+						+ this.arr3[(floorMod(x, this.targetTexture.width))
+						+ (floorMod(y + 1, this.targetTexture.height)) * this.targetTexture.width]) / 4.0F * 0.8F;
 				this.arr3[x + y * this.targetTexture.width] += this.arr4[x + y * this.targetTexture.width] * 0.01F;
 				if (this.arr3[x + y * this.targetTexture.width] < 0.0F) {
 					this.arr3[x + y * this.targetTexture.width] = 0.0F;
@@ -79,7 +81,7 @@ public class DynamicTextureLavaFlowing extends DynamicTexture {
 		this.arr1 = var11;
 
 		for (int i = 0; i < this.targetTexture.getArea(); ++i) {
-			var3 = this.arr1[pmod(i - this.ticks / 3 * this.targetTexture.width, this.targetTexture.getArea())] * 2.0F;
+			var3 = this.arr1[floorMod(i - this.ticks / 3 * this.targetTexture.width, this.targetTexture.getArea())] * 2.0F;
 			if (var3 > 1.0F) {
 				var3 = 1.0F;
 			}
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java
index 256db012f..0dc0e7182 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureLavaStill.java
@@ -4,6 +4,8 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 
+import static java.lang.Math.floorMod;
+
 public class DynamicTextureLavaStill extends DynamicTexture {
 
 	private float[] arr1;
@@ -42,21 +44,21 @@ public class DynamicTextureLavaStill extends DynamicTexture {
 
 				for (g = i - 1; g <= i + 1; ++g) {
 					for (b = j - 1; b <= j + 1; ++b) {
-						var8 = pmod(g + x2, this.targetTexture.width);
-						var9 = pmod(b + y2, this.targetTexture.height);
+						var8 = floorMod(g + x2, this.targetTexture.width);
+						var9 = floorMod(b + y2, this.targetTexture.height);
 						var3 += this.arr1[var8 + var9 * this.targetTexture.width];
 					}
 				}
 
 				this.arr2[i + j * this.targetTexture.width] = var3 / 10.0F
-						+ (this.arr3[(pmod(i, this.targetTexture.width))
-						+ (pmod(j, this.targetTexture.height)) * this.targetTexture.width]
-						+ this.arr3[(pmod(i + 1, this.targetTexture.width))
-						+ (pmod(j, this.targetTexture.height)) * this.targetTexture.width]
-						+ this.arr3[(pmod(i + 1, this.targetTexture.width))
-						+ (pmod(j + 1, this.targetTexture.height)) * this.targetTexture.width]
-						+ this.arr3[(pmod(i, this.targetTexture.width))
-						+ (pmod(j + 1, this.targetTexture.height)) * this.targetTexture.width]) / 4.0F * 0.8F;
+						+ (this.arr3[(floorMod(i, this.targetTexture.width))
+						+ (floorMod(j, this.targetTexture.height)) * this.targetTexture.width]
+						+ this.arr3[(floorMod(i + 1, this.targetTexture.width))
+						+ (floorMod(j, this.targetTexture.height)) * this.targetTexture.width]
+						+ this.arr3[(floorMod(i + 1, this.targetTexture.width))
+						+ (floorMod(j + 1, this.targetTexture.height)) * this.targetTexture.width]
+						+ this.arr3[(floorMod(i, this.targetTexture.width))
+						+ (floorMod(j + 1, this.targetTexture.height)) * this.targetTexture.width]) / 4.0F * 0.8F;
 				
 				this.arr3[i + j * this.targetTexture.width] += this.arr4[i + j * this.targetTexture.width] * 0.01F;
 				if (this.arr3[i + j * this.targetTexture.width] < 0.0F) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
index f6bde9165..be34c4c97 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureWaterFlow.java
@@ -7,6 +7,8 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 
+import static java.lang.Math.floorMod;
+
 public class DynamicTextureWaterFlow extends DynamicTexture {
 	
 	private final Minecraft mc = Minecraft.getMinecraft();
@@ -40,8 +42,8 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 				float pow = 0.0F;
 
 				for (int k = y - 2; k <= y; ++k) {
-					int xi = pmod(x, this.targetTexture.width);
-					int yi = pmod(k, this.targetTexture.height);
+					int xi = floorMod(x, this.targetTexture.width);
+					int yi = floorMod(k, this.targetTexture.height);
 					pow += this.current[xi + yi * this.targetTexture.width];
 				}
 
@@ -69,7 +71,7 @@ public class DynamicTextureWaterFlow extends DynamicTexture {
 
         byte[] imageData = getImageData(this.layerColor);
 		for (int i = 0; i < this.targetTexture.getArea(); ++i) {
-			float pow = this.current[pmod(i - this.ticks * this.targetTexture.width, this.targetTexture.getArea())];
+			float pow = this.current[floorMod(i - this.ticks * this.targetTexture.width, this.targetTexture.getArea())];
 			pow = MathHelper.clamp(pow, 0.0f, 1.0f);
 			float pp = pow * pow;
 
